import java.net.*;
import java.io.*;


public class Server extends Thread
{
	
	private boolean server_toRun = true;
	
	
	Server(){
		start();
	}
	
	
	public void run(){
	  	try{
		  ThreadPool tp = new ThreadPool(100);
		  tp.initializePool();
		  ServerSocket ss = new ServerSocket(7777);
		  
		  while(server_toRun)
			{
				Socket s = ss.accept();
				
				ClientManager cm = tp.getClientManager();
				System.out.println("thread in use: "+cm);
				//System.out.println("3s");
				cm.init(this,s.getInputStream(), s.getOutputStream());
			}
			tp.closePool();
			System.out.println("Server quits... GoodBye");
			System.exit(0);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		

	}
	
	public static void main(String args[])
	{		
		new Server();
	}
	
	
	public synchronized void stopServer(){
		System.out.println("stopServer invocato");
	  server_toRun = false;
	}
	
}